Package com.smartgwt.client.widgets

# Class HTMLPane

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.Canvas
com.smartgwt.client.widgets.HTMLFlow
com.smartgwt.client.widgets.HTMLPane

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `HasClearHandlers`, `HasClickHandlers`, `HasContentLoadedHandlers`, `HasDoubleClickHandlers`, `HasDragMoveHandlers`, `HasDragRepositionMoveHandlers`, `HasDragRepositionStartHandlers`, `HasDragRepositionStopHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDropHandlers`, `HasDropMoveHandlers`, `HasDropOutHandlers`, `HasDropOverHandlers`, `HasFocusChangedHandlers`, `HasHoverHandlers`, `HasHoverHiddenHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseStillDownHandlers`, `HasMouseUpHandlers`, `HasMouseWheelHandlers`, `HasMovedHandlers`, `HasParentMovedHandlers`, `HasResizedHandlers`, `HasRightMouseDownHandlers`, `HasRuleContextChangedHandlers`, `HasScrolledHandlers`, `HasShowContextMenuHandlers`, `HasVisibilityChangedHandlers`

public class HTMLPane extends HTMLFlow
Subclass of `HTMLFlow` configured to display HTML content in a pane of specified size. If the HTML content is larger than the size of the pane, the pane will provide scrollbars for viewing clipped content.

HTML content can be specified directly via `contents`, or loaded from a URL via the property `contentsURL`. This method of loading is for simple HTML content only; Smart GWT components should be loaded via the `ViewLoader` class.

HTMLPanes have the ability to render snippets of HTML directly in the document, or use an IFRAME to render a complete HTML page. See `contentsType` for more information

You can set the size of an HTMLPane directly via the width and height properties, or indirectly by placing the HTMLPane in a container component (`Layout`, `Window`, `SectionStack`, etc) that manages the sizes of its members.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HTMLPane()`
  `HTMLPane(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `protected JavaScriptObject`
  `create()`
  `boolean`
  `getAutoDeriveContentsType()`
  If `ContentsType` is not explicitly specified, should it be automatically derived?
  `String`
  `getContents()`
  String of HTML contents for this component - may be a fragment of HTML to display or a complete HTML page.
  `ContentsType`
  `getContentsType()`
  The `contentsType` attribute governs whether the contents of this htmlFlow are a fragment of HTML to inserted directly into the DOM, or a complete HTML page to be displayed in an IFRAME.
  `String`
  `getContentsURL()`
  If specified the HTMLFlow will load its contents from this URL instead of displaying `this.contents`.
  `Map`
  `getContentsURLParams()`
  Parameters to be sent to the contentsURL when fetching content.
  `int`
  `getDefaultHeight()`
  Default height for the component.
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `static HTMLPane`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `Overflow`
  `getOverflow()`
  HTMLPanes are `overflow:"auto"` by default.
  `boolean`
  `getSupportsContentsAsPage()`
  Can this component have its `contents` specified as a complete standalone HTML page to be rendered into an embedded IFRAME?
  `HTMLPane`
  `setAutoDeriveContentsType(boolean autoDeriveContentsType)`
  If `ContentsType` is not explicitly specified, should it be automatically derived?
  `HTMLPane`
  `setContents(String contents)`
  String of HTML contents for this component - may be a fragment of HTML to display or a complete HTML page.
  `HTMLPane`
  `setContentsType(ContentsType contentsType)`
  The `contentsType` attribute governs whether the contents of this htmlFlow are a fragment of HTML to inserted directly into the DOM, or a complete HTML page to be displayed in an IFRAME.
  `HTMLPane`
  `setContentsURL(String contentsURL)`
  If specified the HTMLFlow will load its contents from this URL instead of displaying `this.contents`.
  `HTMLPane`
  `setContentsURLParams(Map contentsURLParams)`
  Parameters to be sent to the contentsURL when fetching content.
  `HTMLPane`
  `setDefaultHeight(int defaultHeight)`
  Default height for the component.
  `static void`
  `setDefaultProperties(HTMLPane hTMLPaneProperties)`
  Class level method to set the default properties of this class.
  `void`
  `setIFrameURL(String url)`
  Sets the `contentsURL` of this HTMLPane to the supplied url, and the `contentsType` to `ContentsType.PAGE`, provided the HTMLPane hasn't been `drawn`.
  `LogicalStructureObject`
  `setLogicalStructure(HTMLPaneLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `HTMLPane`
  `setOverflow(Overflow overflow)`
  HTMLPanes are `overflow:"auto"` by default.
  `HTMLPane`
  `setSupportsContentsAsPage(boolean supportsContentsAsPage)`
  Can this component have its `contents` specified as a complete standalone HTML page to be rendered into an embedded IFRAME?

  ### Methods inherited from class com.smartgwt.client.widgets.HTMLFlow

  `addContentLoadedHandler, fetchRelatedData, fetchRelatedData, fetchRelatedData, getAllowCaching, getAutoChangeProtocol, getCanSelectText, getCaptureSCComponents, getDefaultWidth, getDynamicContents, getEvalScriptBlocks, getHttpMethod, getIframeSandbox, getLoadingMessage, getSelectContentOnSelectAll, getStructuralHTMLTags, isPageHTML, loadingContent, setAllowCaching, setAutoChangeProtocol, setCanSelectText, setCaptureSCComponents, setDefaultProperties, setDefaultWidth, setDynamicContents, setEvalScriptBlocks, setHttpMethod, setIframeSandbox, setLoadingMessage, setLogicalStructure, setSelectContentOnSelectAll, setStructuralHTMLTags, transformHTML`

  ### Methods inherited from class com.smartgwt.client.widgets.Canvas

  `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, contentsComponentConnected, dataContextChanged, dataContextCriteriaChanged, deparent, depeer, disable, doValueDictation, doVoiceCommand, enable, encloses, endBatchCreation, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAllCanvases, getAllCanvases, getAllCanvases, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAriaStateDefaults, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoRevertStyles, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBorderRadiusAsString, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanDropContent, getCanDropFiles, getCanFocus, getCanHover, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenAsStringArray, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getChildTabPosition, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContentsComponentDefaults, getContextMenu, getControlHeight, getCorrectZoomOverflow, getCursor, getDataContext, getDataContextCriteria, getDataContextCriteria, getDataPath, getDeferActionConversion, getDefiningProperty, getDefiningPropertyName, getDefiningPropertyNameOptions, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getEditProxyConstructor, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getEvents, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverScreen, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentCanvasAsString, getParentElement, getParentElementAsString, getPeers, getPendingMarkerStyle, getPendingMarkerVisible, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShareCriteria, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowFocusOutline, getShowHover, getShowHoverComponents, getShowPointer, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSingleDiv, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getSuppressRedraw, getTabIndex, getTestDataContext, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getTopLevelComponents, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDataContextCriteria, getUseDragMask, getUseGeneratedStyles, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getWorkflows, getZIndex, getZIndex, handleDataContextCriteria, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, initComplete, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, onInit, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerAIService, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, resolveContentsComponent, revealChild, revealChild, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAlign, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoRevertStyles, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanDropContent, setCanDropFiles, setCanFocus, setCanHover, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContentsComponentDefaults, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataPath, setDefaultNativeAutoHideScrollbars, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDeferActionConversion, setDefiningProperty, setDefiningPropertyNameOptions, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setEditProxyConstructor, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverScreen, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentCanvas, setParentElement, setParentElement, setPeers, setPendingMarkerStyle, setPendingMarkerVisible, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShareCriteria, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowFocusOutline, setShowHover, setShowHoverComponents, setShowPointer, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSingleDiv, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setSuppressRedraw, setTabIndex, setTestDataContext, setTitle, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDataContextCriteria, setUseDragMask, setUseGeneratedStyles, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setWorkflows, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPendingMarker, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, startBatchCreation, startDebuggingOverflow, stopDebuggingOverflow, subtractRects, supportsValueDictation, supportsVoiceCommands, unregisterAIService, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAutoDraw, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoDraw, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### HTMLPane

    public HTMLPane()

  - ### HTMLPane

    public HTMLPane(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static HTMLPane getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `HTMLFlow`

  - ### setAutoDeriveContentsType

    public HTMLPane setAutoDeriveContentsType(boolean autoDeriveContentsType)
    If `ContentsType` is not explicitly specified, should it be automatically derived?

    If set to true, this component will use `isPageHTML()` to determine whether the contents are a standalone HTML page which should be rendered into an embedded IFRAME rather than written directly into the component's handle in the DOM.

    Note that this property will auto derive the appropriate contents type for both explicitly specified `contents` and for HTML loaded from the `contentsURL`

    See `ContentsType` for further information on displaying complete HTML pages in an IFRAME.

    Overrides:
      `setAutoDeriveContentsType` in class `HTMLFlow`
    Parameters:
      `autoDeriveContentsType` - New autoDeriveContentsType value. Default value is false
    Returns:
      `HTMLPane` instance, for chaining setter calls

  - ### getAutoDeriveContentsType

    public boolean getAutoDeriveContentsType()
    If `ContentsType` is not explicitly specified, should it be automatically derived?

    If set to true, this component will use `isPageHTML()` to determine whether the contents are a standalone HTML page which should be rendered into an embedded IFRAME rather than written directly into the component's handle in the DOM.

    Note that this property will auto derive the appropriate contents type for both explicitly specified `contents` and for HTML loaded from the `contentsURL`

    See `ContentsType` for further information on displaying complete HTML pages in an IFRAME.

    Overrides:
      `getAutoDeriveContentsType` in class `HTMLFlow`
    Returns:
      Current autoDeriveContentsType value. Default value is false

  - ### setContents

    public HTMLPane setContents(String contents)
    String of HTML contents for this component - may be a fragment of HTML to display or a complete HTML page. See `HTMLFlow.contentsType` and `HTMLFlow.supportsContentsAsPage`.

    To load HTML contents from a URL, use `HTMLFlow.contentsURL` instead of this property. If `contentsURL` is non-null, `contents` will be ignored.

    Overrides:
      `setContents` in class `HTMLFlow`
    Parameters:
      `contents` - New contents value. Default value is "&nbsp;"
    Returns:
      `HTMLPane` instance, for chaining setter calls
    See Also:
      - `HTMLFlow.setContentsURL(java.lang.String)`
      - `HTMLFlow.setDynamicContents(java.lang.Boolean)`
      - `HTMLString`

  - ### getContents

    public String getContents()
    String of HTML contents for this component - may be a fragment of HTML to display or a complete HTML page. See `HTMLFlow.contentsType` and `HTMLFlow.supportsContentsAsPage`.

    To load HTML contents from a URL, use `HTMLFlow.contentsURL` instead of this property. If `contentsURL` is non-null, `contents` will be ignored.

    Overrides:
      `getContents` in class `HTMLFlow`
    Returns:
      Current contents value. Default value is "&nbsp;"
    See Also:
      - `HTMLFlow.getContentsURL()`
      - `HTMLFlow.getDynamicContents()`
      - `HTMLString`

  - ### setContentsType

    public HTMLPane setContentsType(ContentsType contentsType)
    The `contentsType` attribute governs whether the contents of this htmlFlow are a fragment of HTML to inserted directly into the DOM, or a complete HTML page to be displayed in an IFRAME. If not explicitly specified, `autoDeriveContentsType` may be set to automatically determine the appropriate contents type by analyzing the contents of the component. If `autoDeriveContentsType` is false and `contentsType` is not explicitly specified, contents will always be assumed to be `"fragment"`.

    HTMLFlow contents may be `directly specified` or loaded from a `specified URL`. Note that if `supportsContentsAsPage` is false and no `contentsURL` is specified, the contents string will always be assumed to be a fragment, even if `ContentsType` is explicitly set to `"page"`.

    Note that an HTMLFlow with contentsType:"page" should not be used to load and display a page containing a set of Smart GWT components into the application. To dynamically load Smart GWT components, use `ViewLoader`, never this mechanism (click `here` for why).

    Scripting, CSS and scoping considerations for HTMLFlow contents
    The following considerations apply to HTMLFlow contents, whether directly specified or loaded from a contentsURL.

    When contentsType is `"page"`, the HTML content will be rendered as a standalone document using an IFRAME. Use `iframeSandbox` to specify IFRAME restrictions using the native sandbox attribute. Note that any script (if allowed) will be executed in the scope of the embedded IFRAME window, not the main application window. Similarly, other features like css stylesheets loaded by the HTMLFlow will apply to the IFRAME window only, and the IFRAME will not pick up css style from the main application by default.

    When contentsType is `"fragment"`, if script is encountered within the HTML fragment it will be evaluated in the scope of the main application if `evalScriptBlocks` is enabled. Developers should be aware that this evaluation occurs as part of the draw/redraw process, but unlike script embedded directly in a static HTML page, it is not processed by the browser while the elements are being written into the DOM and `document.write(...)` can not be used to modify the HTML as it is being rendered. In this mode, since the contents is written directly into the DOM, standard css styling for the page will be applied.

    Note that if `autoDeriveContentsType` is enabled, the default set of recognized `structuralHTMLTags` include `<script&gt`, so HTML contents including script will display as `contentsType:"page"`. The list of `structuralHTMLTags` can be modified to exclude script tags if desired.

    Overrides:
      `setContentsType` in class `HTMLFlow`
    Parameters:
      `contentsType` - New contentsType value. Default value is null
    Returns:
      `HTMLPane` instance, for chaining setter calls

  - ### getContentsType

    public ContentsType getContentsType()
    The `contentsType` attribute governs whether the contents of this htmlFlow are a fragment of HTML to inserted directly into the DOM, or a complete HTML page to be displayed in an IFRAME. If not explicitly specified, `autoDeriveContentsType` may be set to automatically determine the appropriate contents type by analyzing the contents of the component. If `autoDeriveContentsType` is false and `contentsType` is not explicitly specified, contents will always be assumed to be `"fragment"`.

    HTMLFlow contents may be `directly specified` or loaded from a `specified URL`. Note that if `supportsContentsAsPage` is false and no `contentsURL` is specified, the contents string will always be assumed to be a fragment, even if `ContentsType` is explicitly set to `"page"`.

    Note that an HTMLFlow with contentsType:"page" should not be used to load and display a page containing a set of Smart GWT components into the application. To dynamically load Smart GWT components, use `ViewLoader`, never this mechanism (click `here` for why).

    Scripting, CSS and scoping considerations for HTMLFlow contents
    The following considerations apply to HTMLFlow contents, whether directly specified or loaded from a contentsURL.

    When contentsType is `"page"`, the HTML content will be rendered as a standalone document using an IFRAME. Use `iframeSandbox` to specify IFRAME restrictions using the native sandbox attribute. Note that any script (if allowed) will be executed in the scope of the embedded IFRAME window, not the main application window. Similarly, other features like css stylesheets loaded by the HTMLFlow will apply to the IFRAME window only, and the IFRAME will not pick up css style from the main application by default.

    When contentsType is `"fragment"`, if script is encountered within the HTML fragment it will be evaluated in the scope of the main application if `evalScriptBlocks` is enabled. Developers should be aware that this evaluation occurs as part of the draw/redraw process, but unlike script embedded directly in a static HTML page, it is not processed by the browser while the elements are being written into the DOM and `document.write(...)` can not be used to modify the HTML as it is being rendered. In this mode, since the contents is written directly into the DOM, standard css styling for the page will be applied.

    Note that if `autoDeriveContentsType` is enabled, the default set of recognized `structuralHTMLTags` include `<script&gt`, so HTML contents including script will display as `contentsType:"page"`. The list of `structuralHTMLTags` can be modified to exclude script tags if desired.

    Overrides:
      `getContentsType` in class `HTMLFlow`
    Returns:
      Current contentsType value. Default value is null

  - ### setContentsURL

    public HTMLPane setContentsURL(String contentsURL)
    If specified the HTMLFlow will load its contents from this URL instead of displaying `this.contents`. May be combined with parameters if `contentsURLParams` were specified.

    The HTML retrieved from the target URL may be a complete standalone page to be rendered into its own scope using an IFRAME, or a fragment of HTML to display within this component's handle. See `ContentsType` and `autoDeriveContentsType` for more information.

    Note that the link{loadingMessage} and `httpMethod` features only apply if contentsURL was set and contentsType was not explicitly set to `"page"`

    Overrides:
      `setContentsURL` in class `HTMLFlow`
    Parameters:
      `contentsURL` - New contentsURL value. Default value is null
    Returns:
      `HTMLPane` instance, for chaining setter calls
    See Also:
      - `URL`

  - ### getContentsURL

    public String getContentsURL()
    If specified the HTMLFlow will load its contents from this URL instead of displaying `this.contents`. May be combined with parameters if `contentsURLParams` were specified.

    The HTML retrieved from the target URL may be a complete standalone page to be rendered into its own scope using an IFRAME, or a fragment of HTML to display within this component's handle. See `ContentsType` and `autoDeriveContentsType` for more information.

    Note that the link{loadingMessage} and `httpMethod` features only apply if contentsURL was set and contentsType was not explicitly set to `"page"`

    Overrides:
      `getContentsURL` in class `HTMLFlow`
    Returns:
      Current contentsURL value. Default value is null
    See Also:
      - `URL`

  - ### setContentsURLParams

    public HTMLPane setContentsURLParams(Map contentsURLParams)
    Parameters to be sent to the contentsURL when fetching content.
    Overrides:
      `setContentsURLParams` in class `HTMLFlow`
    Parameters:
      `contentsURLParams` - New contentsURLParams value. Default value is null
    Returns:
      `HTMLPane` instance, for chaining setter calls

  - ### getContentsURLParams

    public Map getContentsURLParams()
    Parameters to be sent to the contentsURL when fetching content.
    Returns:
      Current contentsURLParams value. Default value is null

  - ### setDefaultHeight

    public HTMLPane setDefaultHeight(int defaultHeight)
    Default height for the component.

    For a component that should potentially be sized automatically by a Layout, set this property rather than `height` directly, because Layouts regard a height setting as an explicit size that shouldn't be changed.

    Note : This is an advanced setting

    Overrides:
      `setDefaultHeight` in class `HTMLFlow`
    Parameters:
      `defaultHeight` - New defaultHeight value. Default value is 200
    Returns:
      `HTMLPane` instance, for chaining setter calls
    See Also:
      - `Sizing overview and related methods`

  - ### getDefaultHeight

    public int getDefaultHeight()
    Default height for the component.

    For a component that should potentially be sized automatically by a Layout, set this property rather than `height` directly, because Layouts regard a height setting as an explicit size that shouldn't be changed.

    Overrides:
      `getDefaultHeight` in class `HTMLFlow`
    Returns:
      Current defaultHeight value. Default value is 200
    See Also:
      - `Sizing overview and related methods`

  - ### setOverflow

    public HTMLPane setOverflow(Overflow overflow)
    HTMLPanes are `overflow:"auto"` by default.

    Note that for `contentsType:"page"`, `overflow:"visible"` is not supported.

    Overrides:
      `setOverflow` in class `HTMLFlow`
    Parameters:
      `overflow` - New overflow value. Default value is Canvas.AUTO
    Returns:
      `HTMLPane` instance, for chaining setter calls
    See Also:
      - `Sizing overview and related methods`

  - ### getOverflow

    public Overflow getOverflow()
    HTMLPanes are `overflow:"auto"` by default.

    Note that for `contentsType:"page"`, `overflow:"visible"` is not supported.

    Overrides:
      `getOverflow` in class `HTMLFlow`
    Returns:
      Current overflow value. Default value is Canvas.AUTO
    See Also:
      - `Sizing overview and related methods`

  - ### setSupportsContentsAsPage

    public HTMLPane setSupportsContentsAsPage(boolean supportsContentsAsPage)
    Can this component have its `contents` specified as a complete standalone HTML page to be rendered into an embedded IFRAME?

    If true, if `ContentsType` is specified as, or `derived to be` "page", the contents will be rendered into an embedded IFRAME using the `srcdoc` attribute rather than written directly into the component handle.

    If false, contentsType has no effect unless contents are being loaded from an explicitly specified `contentsURL`

    Overrides:
      `setSupportsContentsAsPage` in class `HTMLFlow`
    Parameters:
      `supportsContentsAsPage` - New supportsContentsAsPage value. Default value is true
    Returns:
      `HTMLPane` instance, for chaining setter calls

  - ### getSupportsContentsAsPage

    public boolean getSupportsContentsAsPage()
    Can this component have its `contents` specified as a complete standalone HTML page to be rendered into an embedded IFRAME?

    If true, if `ContentsType` is specified as, or `derived to be` "page", the contents will be rendered into an embedded IFRAME using the `srcdoc` attribute rather than written directly into the component handle.

    If false, contentsType has no effect unless contents are being loaded from an explicitly specified `contentsURL`

    Overrides:
      `getSupportsContentsAsPage` in class `HTMLFlow`
    Returns:
      Current supportsContentsAsPage value. Default value is true

  - ### setDefaultProperties

    public static void setDefaultProperties(HTMLPane hTMLPaneProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `hTMLPaneProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### setIFrameURL

    public void setIFrameURL(String url)
    Sets the `contentsURL` of this HTMLPane to the supplied url, and the `contentsType` to `ContentsType.PAGE`, provided the HTMLPane hasn't been `drawn`. Throws an AssertionError RuntimeException in GWT Classic DevMode if the HTMLPane has already been drawn.
    Parameters:
      `url` - the IFrame url

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(HTMLPaneLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `HTMLFlow`